#ifndef(ADDITIONTOOLS_Inc_Temp)
#declare ADDITIONTOOLS_Inc_Temp = version;
#version 3.7;






/******

return 0 ~ 2*pi

******/
#declare f_theta =
function(x, y) {
select(y, 2*pi - acos(x/sqrt(x*x + y*y)) , acos(x/sqrt(x*x + y*y)))

}


/*
#declare f_r =
function(x, y) {
sqrt(x*x + y*y)
}
*/



// ------------- perturbation ------------------------------

// w >0 JAX > 0
// amplitude ud 0 ~ 1
// var ܲWv1

#declare f_noise_perturbation =
function(var, amplitude, frq) {
var + amplitude *f_snoise3d(frq*var, 0, 0) *atan(var*pi/2)/(pi/2)
}




#declare f_noise_perturbation_low_frq =
function(var, amplitude) {
f_noise_perturbation(var, amplitude, 0.33)
}



#declare f_noise_perturbation_mid_frq =
function(var, amplitude) {
f_noise_perturbation(var, amplitude, 1.0)
}



#declare f_noise_perturbation_high_frq =
function(var, amplitude) {
f_noise_perturbation(var, amplitude, 3.0)
}




// --------- value adjust -----------------------

#declare f_sharp_adjust =
function(value, slope_m) {
select(
    value - (0.5 - 0.5/slope_m),
    0,
    select(
        value - (0.5 + 0.5/slope_m),
        slope_m*value + 0.5 - 0.5*slope_m,
        1
    )
)
}


//--------------normal distribution---------------

#declare f_nor_distri =
function(x, expect, deviation) {
(1/deviation/sqrt(2*pi))* exp(-pow((x - expect)/deviation, 2)/2)
}













//-----------blend------------------------------


#declare f_linear_blend_rise =
function(var, var0, var1) {
(var - var0)/(var1 - var0)
}

#declare f_linear_blend_fall =
function(var, var0, var1) {
1 - f_linear_blend_rise(var, var0, var1)
}





#declare f_cos_blend_rise =
function(var, var0, var1) {
1 - pow(cos( (pi/2)*(var - var0)/(var1 - var0) ), 2)

}

#declare f_cos_blend_fall =
function(var, var0, var1) {
1 - f_cos_blend_rise(var, var0, var1)
}







//---------------step ---------------------


#declare f_parbl_step_rise =
function(var, var0, var1) {
1 - pow((var - var1)/(var1 - var0), 2)
}

#declare f_parbl_step_fall =
function(var, var0, var1) {
1 - pow((var - var0)/(var1 - var0), 2)
}





#version ADDITIONTOOLS_Inc_Temp;
#end//addition_tools.inc
